#ifndef VPADETERMINIZER_H_
#define VPADETERMINIZER_H_

#include "automaton/PDA/VisiblyPushdownNPDA.h"

namespace determinize {

/**
 * Class for running basic determinization algorithm on vpa.
 */
class VPADeterminizer {
public:
	static label::Label packToDVPAStateLabel(std::set<std::pair<label::Label, label::Label>>&& data);

	static std::set<std::pair<label::Label, label::Label>> unpackFromDVPAStateLabel(const label::Label& data);

	static label::Label packToDVPAStackSymbolLabel(std::pair<std::set<std::pair<label::Label, label::Label>>, alphabet::Symbol>&& data);

	static std::pair<std::set<std::pair<label::Label, label::Label>>, alphabet::Symbol> unpackFromDVPAStackSymbolLabel(const label::Label& data);
	/**
	 * Runs determinization algorithm on nondeterministic vpa given in constructor.
	 *
	 * @return deterministic visibly pushdown automaton
	 */
	static automaton::VisiblyPushdownNPDA determinize(const automaton::VisiblyPushdownNPDA& nondeterministic);

};

} /* namespace determinize */

#endif /* VPADETERMINIZER_h_ */
